<?php

/**
 * consecutivo_caja actions.
 *
 * @package    cartera
 * @subpackage consecutivo_caja
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class consecutivo_cajaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_CONSECUTIVO_CAJA',
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_CONSECUTIVO_CAJA' =>
        array(
            'id_punto_venta' => 'id_punto_venta',
            'id_caja' => 'id_caja',
            'consec_fac' => 'consec_fac',
            'sesion_caja' => 'sesion_caja'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_CONSECUTIVO_CAJA' => array(
            'id_caja,a' => array('!=' => array(-1)),
            'id_caja,b' => array('=' => array('id_caja')),
            'id_punto_venta' => array('=' => array('id_punto_venta')),
            'sesion_caja' => array('=' => array('sesion_caja'))
        //      'rownum,start' => array('>' => array('_startRow')),
        //     'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_caja', 'sesion_caja'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_caja'; //identificador de la tabla
    protected $id_names = array('id_caja', 'id_punto_venta'); //llave primaria
    protected $field_names = array('id_punto_venta', 'id_caja', 'consec_fac', 'sesion_caja'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_CONSECUTIVO_CAJA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_caja'; //identificador unico de la tabla

    /**
     * Obtener consecutivo para una caja  y punto de venta
     * Validar que datos de aprobacion como fecha vencimiento
     * y consecutivo de numeracion facturas
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");



        /*
         * Manejo de errores
         */
        try {


            /*
             * Variables obligatorias
             */
            $id_caja = $request['id_caja'];
            $id_punto_venta = $request['id_punto_venta'];
            /*
             * Para definir si es para apertura o cierre
             * consultta de factura se toma como apertura
             */
            if ($request['estado'] == 'true') {
                $estado = 1;
            } else {
                $estado = 0;
            }

            /*
             * obtener la ultima aprobacion por caja/punto de venta
             */
            //sentencia sql
            $sql = <<<EOD
select * from ca_aprob_caja
where
actual = 1
and id_caja = $id_caja
and id_punto_venta = $id_punto_venta
EOD;
            //ejecuta el sql
            $result = CN_TABLE::executeSQL($sql);

            //la caja posee aprobacion actual
            if (count($result) > 0) {

                $fechaactual = strtotime(CN_TABLE::fechaSistema()); //fecha actual del sistema
                $fechaevento = strtotime($result[0]['fecha_vencimiento']); //fecha de vigencia aprobacion
                //fecha_vencimiento vigente aprobacion actual
                if ($fechaactual <= $fechaevento) {
                    $this->logMessage("[CONSECUTIVO CAJA] fecha_vencimiento vigente aprobacion actual.");

                    $num_aprob_ini = $result[0]['num_aprob_ini'];
                    $num_aprob_fin = $result[0]['num_aprob_fin'];

                    /*
                     * Consultar el consecutivo de la caja por punto de venta
                     */
                    //sentencia sql
                    $sql = <<<EOD
select * from ca_consecutivo_caja
where
id_caja = $id_caja
and id_punto_venta = $id_punto_venta
EOD;
                    //ejecuta el sql
                    $result = CN_TABLE::executeSQL($sql);

                    $consec_fac = $result[0]['consec_fac'];
                    $sesion_caja = $result[0]['sesion_caja'];


                    /*
                     * si consecutivo factura es cero
                     * este dentro de rango de numeros de aprobacion inicial y final
                     * si es igual al numero de aprobacion final si es igual al consecutivo de factura no es permitivo - y no hay mas consecutivo
                     */
                    $validar_sec = false;
                    $mensaje = "[CONSECUTIVO CAJA] Verificar consecutivos de facturas.";

                    /**
                     * Consecutivo segun estado caja
                     */
                    //consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual
                    if ($estado == 0) {
                        $this->logMessage("[CONSECUTIVO CAJA] La caja se va ha cerrar.");
                        $validar_sec = true;
                        $num_factura = $consec_fac;
                    } else {
                        $this->logMessage("[CONSECUTIVO CAJA] consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual");

                        if ($consec_fac == 0) {

                            $validar_sec = true;
                            $num_factura = $num_aprob_ini;
                        } else if ($consec_fac == $num_aprob_fin) {

                            $mensaje = "[CONSECUTIVO CAJA] Consecutivo de factura NO mayor a numero de aprobacion final de la aprobacion de caja actual.";
                            $validar_sec = false;
                            $num_factura = 0;
                        } else {

                            $validar_sec = true;
                            $num_factura = $consec_fac + 1;
                        }
                    }


                    /*
                     * Validar si se uarda el registro segun consecutivo factura
                     * consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual
                     */
                    if ($validar_sec) {
                        $this->logMessage("[CONSECUTIVO CAJA] consecutivo de factura no mayor a numero de aprobacion final de la aprobacion de caja actual.");

                        //si es abrir caja aumenta la sesion
                        if ($estado == 1) {
                            $sesion_caja = $sesion_caja + 1;
                        }

                        //aumentar en el consecutivo de factura y session
                        $result[0]['consec_fac'] = $num_factura;
                        $result[0]['sesion_caja'] = $sesion_caja;

                        $this->list_data = $result;
                    } else {

                        $this->status = 1;
                        $this->mensajeError = $mensaje;
                        $this->list_data = array();
                        $this->logMessage($mensaje);
                    }
                } else {

                    $mensaje = "[CONSECUTIVO CAJA] Fecha de vigencia para la aprobacion esta vencida.";
                    $this->status = 1;
                    $this->mensajeError = $mensaje;
                    $this->list_data = array();
                    $this->logMessage($mensaje);
                }
            } else {

                $mensaje = "[CONSECUTIVO CAJA] La caja no posee aprobacion actual.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
